/*
 * RegistryMapAndConstants.h
 *
 *  Created on: Aug 6, 2017
 *      Author: Christopher Hunt <chunt11@jhmi.edu>
 */

#ifndef CONSTANTS_H_
#define CONSTANTS_H_

// I2C
#define I2C_SDA_PIN         10
#define I2C_SCL_PIN         8
#define INT_PIN				4
#define CALIB_PIN			5

// Constants
#define GRAVITY             9.80665f
#define DEG_2_RAD           0.01745329251f

// MPU9250 Registers
#define MPU9250_ADDR        0x68
#define ACCEL_OUT           0x3B
#define GYRO_OUT            0x43
#define TEMP_OUT            0x41
#define EXT_SENS_DATA_00    0x49

#define ACCEL_CONFIG        0x1C
#define ACCEL_FS_SEL_2G     0x00
#define ACCEL_FS_SEL_4G     0x08
#define ACCEL_FS_SEL_8G     0x10
#define ACCEL_FS_SEL_16G    0x18

#define GYRO_CONFIG         0x1B
#define GYRO_FS_SEL_250DPS  0x00
#define GYRO_FS_SEL_500DPS  0x08
#define GYRO_FS_SEL_1000DPS 0x10
#define GYRO_FS_SEL_2000DPS 0x18

#define ACCEL_CONFIG2       0x1D
#define ACCEL_DLPF_184      0x01
#define ACCEL_DLPF_92       0x02
#define ACCEL_DLPF_41       0x03
#define ACCEL_DLPF_20       0x04
#define ACCEL_DLPF_10       0x05
#define ACCEL_DLPF_5        0x06

#define CONFIG              0x1A
#define GYRO_DLPF_184       0x01
#define GYRO_DLPF_92        0x02
#define GYRO_DLPF_41        0x03
#define GYRO_DLPF_20        0x04
#define GYRO_DLPF_10        0x05
#define GYRO_DLPF_5         0x06

#define SMPDIV              0x19

#define INT_PIN_CFG         0x37
#define INT_ENABLE          0x38
#define INT_DISABLE         0x00
#define INT_PULSE_50US      0x00
#define INT_RAW_RDY_EN      0x01

#define PWR_MGMNT_1         0x6B
#define PWR_RESET           0x80
#define CLOCK_SEL_PLL       0x01

#define PWR_MGMNT_2         0x6C
#define SEN_ENABLE          0x00

#define USER_CTRL           0x6A
#define I2C_MST_EN          0x20
#define I2C_MST_CLK         0x0D
#define I2C_MST_CTRL        0x24
#define I2C_SLV0_ADDR       0x25
#define I2C_SLV0_REG        0x26
#define I2C_SLV0_DO         0x63
#define I2C_SLV0_CTRL       0x27
#define I2C_SLV0_EN         0x80
#define I2C_READ_FLAG       0x80

#define WHO_AM_I            0x75

// AK8963 Registers
#define AK8963_I2C_ADDR     0x0C

#define AK8963_HXL          0x03

#define AK8963_CNTL1        0x0A
#define AK8963_PWR_DOWN     0x00
#define AK8963_CNT_MEAS1    0x12
#define AK8963_CNT_MEAS2    0x16
#define AK8963_FUSE_ROM     0x0F

#define AK8963_CNTL2        0x0B
#define AK8963_RESET        0x01

#define AK8963_ASA          0x10

#define AK8963_8HZ          0x02  // continuous data read at 8 Hz
#define AK8963_100HZ        0x06  // continuous data read at 100 Hz

#define AK8963_ST1          0x02  // data ready status bit 0
#define AK8963_OUT          0x03  // data
#define AK8963_ST2          0x09  // data overflow bit 3 and data read error status bit 2

#define AK8963_WHO_AM_I     0x00

#endif /* CONSTANTS_H_ */
